diff --git a/src/modules/QPainter/QPainterWriter.cpp b/src/modules/QPainter/QPainterWriter.cpp
index 92a3225f..fcb11587 100644
--- a/src/modules/QPainter/QPainterWriter.cpp
+++ b/src/modules/QPainter/QPainterWriter.cpp
@@ -72,9 +72,9 @@ void Drawable::draw(const VideoFrame &newVideoFrame, bool canRepaint, bool entir
 
 void Drawable::resizeEvent(QResizeEvent *e)
 {
-    const qreal dpr = devicePixelRatioF();
+    const qreal scale = QMPlay2Core.getVideoDevicePixelRatio();
     Functions::getImageSize(writer.aspect_ratio, writer.zoom, width(), height(), W, H, &X, &Y);
-    Functions::getImageSize(writer.aspect_ratio, writer.zoom, width() * dpr, height() * dpr, imgW, imgH);
+    Functions::getImageSize(writer.aspect_ratio, writer.zoom, width() * scale, height() * scale, imgW, imgH);
     imgW = Functions::aligned(imgW, 8);
 
     imgScaler.destroy();
@@ -82,6 +82,7 @@ void Drawable::resizeEvent(QResizeEvent *e)
 
     draw(VideoFrame(), e ? false : true, true);
 }
+
 void Drawable::paintEvent(QPaintEvent *)
 {
     QPainter p(this);
@@ -94,14 +95,15 @@ void Drawable::paintEvent(QPaintEvent *)
     osd_mutex.lock();
     if (!osd_list.isEmpty())
     {
-        const qreal dpr = devicePixelRatioF();
-        if (!qFuzzyCompare(dpr, 1.0))
-            p.scale(1.0 / dpr, 1.0 / dpr);
+        const qreal scale = QMPlay2Core.getVideoDevicePixelRatio();
+        if (!qFuzzyCompare(scale, 1.0))
+            p.scale(1.0 / scale, 1.0 / scale);
         p.setClipRect(0, 0, imgW, imgH);
-        Functions::paintOSD(true, osd_list, W * dpr / writer.outW, H * dpr / writer.outH, p);
+        Functions::paintOSD(true, osd_list, (qreal)W / writer.outW, (qreal)H / writer.outH, p);
     }
     osd_mutex.unlock();
 }
+
 bool Drawable::event(QEvent *e)
 {
     /* Pass gesture and touch event to the parent */
diff --git a/src/modules/QPainter/QPainterWriter.hpp b/src/modules/QPainter/QPainterWriter.hpp
index f5e0a680..61991e4e 100644
--- a/src/modules/QPainter/QPainterWriter.hpp
+++ b/src/modules/QPainter/QPainterWriter.hpp
@@ -27,23 +27,23 @@
 class QPainterWriter;
 class QMPlay2OSD;
 
-class Drawable final : public QWidget
+class Drawable : public QWidget
 {
 public:
     Drawable(class QPainterWriter &);
-    ~Drawable();
+    ~Drawable() final;
 
     void draw(const VideoFrame &newVideoFrame, bool, bool);
 
-    void resizeEvent(QResizeEvent *) override;
+    void resizeEvent(QResizeEvent *) override final;
 
     VideoFrame videoFrame;
     QList<const QMPlay2OSD *> osd_list;
     int Brightness, Contrast;
     QMutex osd_mutex;
 private:
-    void paintEvent(QPaintEvent *) override;
-    bool event(QEvent *) override;
+    void paintEvent(QPaintEvent *) override final;
+    bool event(QEvent *) override final;
 
     int X, Y, W, H, imgW, imgH;
     QPainterWriter &writer;
@@ -54,28 +54,28 @@ private:
 
 /**/
 
-class QPainterWriter final : public VideoWriter
+class QPainterWriter : public VideoWriter
 {
     friend class Drawable;
 public:
     QPainterWriter(Module &);
 private:
-    ~QPainterWriter();
+    ~QPainterWriter() final;
 
-    bool set() override;
+    bool set() override final;
 
-    bool readyWrite() const override;
+    bool readyWrite() const override final;
 
-    bool processParams(bool *paramsCorrected) override;
+    bool processParams(bool *paramsCorrected) override final;
 
-    QMPlay2PixelFormats supportedPixelFormats() const override;
+    QMPlay2PixelFormats supportedPixelFormats() const override final;
 
-    void writeVideo(const VideoFrame &videoFrame) override;
-    void writeOSD(const QList<const QMPlay2OSD *> &) override;
+    void writeVideo(const VideoFrame &videoFrame) override final;
+    void writeOSD(const QList<const QMPlay2OSD *> &) override final;
 
-    QString name() const override;
+    QString name() const override final;
 
-    bool open() override;
+    bool open() override final;
 
     /**/
 
diff --git a/src/modules/Subtitles/Classic.cpp b/src/modules/Subtitles/Classic.cpp
index d5c4d003..cb8f8bab 100644
--- a/src/modules/Subtitles/Classic.cpp
+++ b/src/modules/Subtitles/Classic.cpp
@@ -167,7 +167,7 @@ bool Classic::toASS(const QByteArray &txt, LibASS *ass, double fps)
                 if (use_mDVD_FPS && (s == 0 || s == 1))
                 {
                     use_mDVD_FPS = false;
-                    const double newFPS = sub.midRef(0, 6).toDouble();
+                    const double newFPS = sub.mid(0, 6).toDouble();
                     if (newFPS > 0.0 && newFPS < 100.0)
                     {
                         fps = newFPS;
diff --git a/src/modules/Subtitles/Classic.hpp b/src/modules/Subtitles/Classic.hpp
index b4270f7f..db15b93d 100644
--- a/src/modules/Subtitles/Classic.hpp
+++ b/src/modules/Subtitles/Classic.hpp
@@ -20,12 +20,12 @@
 
 #include <SubsDec.hpp>
 
-class Classic final : public SubsDec
+class Classic : public SubsDec
 {
 public:
     Classic(bool, double);
 private:
-    bool toASS(const QByteArray &, class LibASS *, double) override;
+    bool toASS(const QByteArray &, class LibASS *, double) override final;
 
     /**/
 
diff --git a/src/qmplay2/CMakeLists.txt b/src/qmplay2/CMakeLists.txt
index c70bd00c..d7509e9a 100644
--- a/src/qmplay2/CMakeLists.txt
+++ b/src/qmplay2/CMakeLists.txt
@@ -112,7 +112,7 @@ if(USE_FREEDESKTOP_NOTIFICATIONS)
     qt5_add_dbus_interface(QMPLAY2_SRC org.freedesktop.Notifications.xml notifications_interface)
     add_definitions(-DNOTIFIES_FREEDESKTOP)
     set(DBUS Qt5::DBus)
-elseif(APPLE)
+elseif(APPLE AND NOT USE_QT4)
     list(APPEND QMPLAY2_HDR headers/NotifiesMacOS.hpp)
     list(APPEND QMPLAY2_SRC NotifiesMacOS.mm)
     find_package(Qt5MacExtras REQUIRED)
@@ -195,11 +195,18 @@ add_library(${PROJECT_NAME} SHARED
 set_target_properties(${PROJECT_NAME} PROPERTIES PREFIX "")
 
 if(APPLE)
-    target_link_libraries(${PROJECT_NAME}
-        PRIVATE
-        Qt5::MacExtras
-        ${APPKIT_LIBRARY}
+    if(USE_QT4)
+        target_link_libraries(${PROJECT_NAME}
+            PRIVATE
+            ${APPKIT_LIBRARY}
     )
+    else()
+        target_link_libraries(${PROJECT_NAME}
+            PRIVATE
+            Qt5::MacExtras
+            ${APPKIT_LIBRARY}
+    )
+    endif()
 endif()
 
 if(WIN32)
@@ -229,14 +236,30 @@ else()
     endif()
 endif()
 
+if(USE_QT4)
+    add_definitions(-I@prefix@/include/QJson4)
+    target_link_libraries(${PROJECT_NAME}
+        PUBLIC
+        Qt4::QtCore
+        Qt4::QtGui
+        Qt4::QtSvg
+        QJson4
+    )
+else()
+    target_link_libraries(${PROJECT_NAME}
+        PUBLIC
+        Qt5::Core
+        Qt5::Gui
+        Qt5::Widgets
+        Qt5::Svg
+        PRIVATE
+        ${QML}
+    )
+endif()
+
 target_link_libraries(${PROJECT_NAME}
-    PUBLIC
-    Qt5::Core
-    Qt5::Gui
-    Qt5::Widgets
     PRIVATE
     ${DBUS}
-    ${QML}
     ${LIBQMPLAY2_LIBS}
 )
 
diff --git a/src/qmplay2/Functions.cpp b/src/qmplay2/Functions.cpp
index 572952e2..554b0100 100644
--- a/src/qmplay2/Functions.cpp
+++ b/src/qmplay2/Functions.cpp
@@ -36,12 +36,16 @@
 #include <QDir>
 #include <QUrl>
 #include <QRegExp>
-#include <QWindow>
+#include <QWidget>
 #include <QLibrary>
 #include <QTextCodec>
 #include <QMessageBox>
 #include <QStyleOption>
 
+#ifdef Q_WS_X11
+#include <QX11Info>
+#endif
+
 extern "C"
 {
     #include <libavformat/version.h>
@@ -58,14 +62,16 @@ static inline void swapArray(quint8 *a, quint8 *b, int size)
     memcpy(b, t, size);
 }
 
-static inline QWindow *getNativeWindow(const QWidget *w)
+static inline WId getNativeWindow(const QWidget *w)
 {
     if (w)
     {
-        if (QWidget *winW = w->window())
-            return winW->windowHandle();
+        if (const QWidget *winW = w->window())
+        {
+            return winW->winId();
+        }
     }
-    return nullptr;
+    return 0;
 }
 
 /**/
@@ -301,7 +307,8 @@ QPixmap Functions::getPixmapFromIcon(const QIcon &icon, QSize size, QWidget *w)
         imgSize.scale(size, size.isEmpty() ? Qt::KeepAspectRatioByExpanding : Qt::KeepAspectRatio);
     }
 
-    return icon.pixmap(getNativeWindow(w), imgSize);
+    Q_UNUSED(w)
+    return icon.pixmap(imgSize);
 }
 void Functions::drawPixmap(QPainter &p, const QPixmap &pixmap, const QWidget *w, Qt::TransformationMode transformationMode, Qt::AspectRatioMode aRatioMode, QSize size, qreal scale)
 {
@@ -347,14 +354,13 @@ void Functions::drawPixmap(QPainter &p, const QPixmap &pixmap, const QWidget *w,
         pixmapSize = pixmap.size();
     }
 
-    const qreal dpr = w->devicePixelRatioF();
+    qreal devicePixelRatio = QMPlay2Core.getVideoDevicePixelRatio();
 
-    pixmapToDraw = pixmapToDraw.scaled(pixmapSize * dpr, Qt::IgnoreAspectRatio, transformationMode);
-    pixmapToDraw.setDevicePixelRatio(dpr);
+    pixmapToDraw = pixmapToDraw.scaled(pixmapSize * devicePixelRatio, Qt::IgnoreAspectRatio, transformationMode);
 
     const QPoint pixmapPos {
-        size.width()  / 2 - int(pixmapToDraw.width()  / (dpr * 2)),
-        size.height() / 2 - int(pixmapToDraw.height() / (dpr * 2))
+        size.width()  / 2 - int(pixmapToDraw.width()  / (devicePixelRatio * 2)),
+        size.height() / 2 - int(pixmapToDraw.height() / (devicePixelRatio * 2))
     };
 
     p.drawPixmap(pixmapPos, pixmapToDraw);
@@ -405,8 +411,8 @@ void Functions::paintOSD(bool rgbSwapped, const QList<const QMPlay2OSD *> &osd_l
         for (int j = 0; j < osd->imageCount(); j++)
         {
             const QMPlay2OSD::Image &img = osd->getImage(j);
-            const QImage qImg = QImage((const uchar *)img.data.constData(), img.rect.width(), img.rect.height(), rgbSwapped ? QImage::Format_RGBA8888 : QImage::Format_ARGB32);
-            painter.drawImage(img.rect.topLeft(), qImg);
+            const QImage qImg = QImage((uchar *)img.data.data(), img.rect.width(), img.rect.height(), QImage::Format_ARGB32);
+            painter.drawImage(img.rect.topLeft(), rgbSwapped ? qImg.rgbSwapped() : qImg);
         }
         if (osd->needsRescale())
             painter.restore();
diff --git a/src/qmplay2/LineEdit.cpp b/src/qmplay2/LineEdit.cpp
index 6f94853d..72176e1b 100644
--- a/src/qmplay2/LineEdit.cpp
+++ b/src/qmplay2/LineEdit.cpp
@@ -19,19 +19,58 @@
 #include <LineEdit.hpp>
 
 #include <QMPlay2Core.hpp>
+#include <Functions.hpp>
 
-#include <QAction>
+#include <QResizeEvent>
+
+LineEditButton::LineEditButton()
+{
+    const QSize iconSize(16, 16);
+    setToolTip(tr("Clear"));
+    setPixmap(Functions::getPixmapFromIcon(QMPlay2Core.getIconFromTheme("edit-clear"), iconSize, this));
+    resize(iconSize);
+    setCursor(Qt::ArrowCursor);
+}
+
+void LineEditButton::mousePressEvent(QMouseEvent *e)
+{
+    if (e->button() & Qt::LeftButton)
+        emit clicked();
+}
+
+/**/
 
 LineEdit::LineEdit(QWidget *parent)
     : QLineEdit(parent)
 {
-    QAction *clearAct = addAction(QMPlay2Core.getIconFromTheme("edit-clear"), TrailingPosition);
-    connect(clearAct, &QAction::triggered, this, &LineEdit::clearText);
-    connect(this, &LineEdit::textChanged, this, [=](const QString &text) {
-        clearAct->setVisible(!text.isEmpty());
-    });
-    clearAct->setToolTip(tr("Clear"));
-    clearAct->setVisible(false);
+    connect(this, SIGNAL(textChanged(const QString &)), this, SLOT(textChangedSlot(const QString &)));
+    connect(&b, SIGNAL(clicked()), this, SLOT(clearText()));
+    setMinimumWidth(b.width() * 2.5);
+    setTextMargins(0, 0, b.width() * 1.5, 0);
+    b.setParent(this);
+    b.hide();
+}
+
+void LineEdit::resizeEvent(QResizeEvent *e)
+{
+    b.move(e->size().width() - b.width() * 1.5, e->size().height() / 2 - b.height() / 2);
+}
+
+void LineEdit::mousePressEvent(QMouseEvent *e)
+{
+    if (!b.underMouse())
+        QLineEdit::mousePressEvent(e);
+}
+
+void LineEdit::mouseMoveEvent(QMouseEvent *e)
+{
+    if (!b.underMouse())
+        QLineEdit::mouseMoveEvent(e);
+}
+
+void LineEdit::textChangedSlot(const QString &str)
+{
+    b.setVisible(!str.isEmpty());
 }
 
 void LineEdit::clearText()
diff --git a/src/qmplay2/QMPlay2Core.cpp b/src/qmplay2/QMPlay2Core.cpp
index 55f775da..56a04b28 100644
--- a/src/qmplay2/QMPlay2Core.cpp
+++ b/src/qmplay2/QMPlay2Core.cpp
@@ -28,7 +28,6 @@
 #include <Version.hpp>
 #include <Module.hpp>
 
-#include <QLoggingCategory>
 #include <QApplication>
 #include <QLibraryInfo>
 #include <QTranslator>
@@ -36,19 +35,19 @@
 #include <QLibrary>
 #include <QPointer>
 #include <QLocale>
-#include <QWindow>
 #include <QFile>
 #include <QDir>
 #if defined Q_OS_WIN
     #include <windows.h>
     #include <powrprof.h>
-#elif defined Q_OS_MACOS
-    #include <QStandardPaths>
 #endif
 
 #include <cstdarg>
 #include <cstdio>
 
+#define QT_VERSION_MAJOR 4
+#define QT_VERSION_MINOR 8 // Qt 4.8.x is the oldest supported Qt version
+
 extern "C"
 {
     #include <libavformat/avformat.h>
@@ -58,19 +57,8 @@ extern "C"
 
 /**/
 
-Q_LOGGING_CATEGORY(ffmpeglog, "FFmpegLog")
-
 static void avQMPlay2LogHandler(void *avcl, int level, const char *fmt, va_list vl)
 {
-    if (level <= AV_LOG_FATAL)
-    {
-        const QByteArray msg = QString::vasprintf(fmt, vl).trimmed().toUtf8();
-        qCCritical(ffmpeglog) << msg.constData();
-    }
-    else
-    {
-        av_log_default_callback(avcl, level, fmt, vl);
-    }
 }
 
 /**/
@@ -109,6 +97,8 @@ QMPlay2CoreClass::QMPlay2CoreClass()
 {
     qmplay2Core = this;
 
+    videoDevicePixelRatio = 1.0;
+
     QFile f(":/Languages.txt");
     if (f.open(QFile::ReadOnly))
     {
@@ -203,8 +193,6 @@ void QMPlay2CoreClass::init(bool loadModules, bool modulesInSubdirs, const QStri
     {
 #if defined(Q_OS_WIN)
         settingsDir = QFileInfo(QSettings(QSettings::IniFormat, QSettings::UserScope, QString()).fileName()).absolutePath() + "/QMPlay2/";
-#elif defined(Q_OS_MACOS)
-        settingsDir = Functions::cleanPath(QStandardPaths::standardLocations(QStandardPaths::DataLocation).value(0, settingsDir));
 #else
         settingsDir = QDir::homePath() + "/.qmplay2/";
 #endif
@@ -414,9 +402,8 @@ QStringList QMPlay2CoreClass::getModules(const QString &type, int typeLen) const
     return modules + availableModules;
 }
 
-qreal QMPlay2CoreClass::getVideoDevicePixelRatio() const
+void QMPlay2CoreClass::setVideoDevicePixelRatio()
 {
-    return getVideoDock()->devicePixelRatioF();
 }
 
 QIcon QMPlay2CoreClass::getIconFromTheme(const QString &iconName, const QIcon &fallback)
diff --git a/src/qmplay2/QMPlay2OSD.cpp b/src/qmplay2/QMPlay2OSD.cpp
index d77bc2ce..7c0ff030 100644
--- a/src/qmplay2/QMPlay2OSD.cpp
+++ b/src/qmplay2/QMPlay2OSD.cpp
@@ -17,13 +17,13 @@
 */
 
 #include <QMPlay2OSD.hpp>
+#include <QAtomicInt>
 
-#include <QAtomicInteger>
-static QAtomicInteger<quint64> g_id;
+static QAtomicInt g_id;
 
 void QMPlay2OSD::genId()
 {
-    m_id = ++g_id;
+    m_id = g_id.fetchAndAddOrdered(1) + 1;
 }
 
 void QMPlay2OSD::clear(bool all)
diff --git a/src/qmplay2/Writer.cpp b/src/qmplay2/Writer.cpp
index 5eb05afd..a09bda50 100644
--- a/src/qmplay2/Writer.cpp
+++ b/src/qmplay2/Writer.cpp
@@ -20,7 +20,7 @@
 
 #include <Functions.hpp>
 
-#include <QSaveFile>
+#include <QFile>
 #include <QBuffer>
 
 #include <memory>
@@ -52,8 +52,10 @@ class QMPlay2FileWriter : public IODeviceWriter
 {
     ~QMPlay2FileWriter()
     {
-        if (auto f = static_cast<QSaveFile *>(m_io.get()))
-            f->commit();
+        if (auto f = static_cast<QFile *>(m_io.get()))
+        {
+            f->close();
+        }
     }
 
     QString name() const override final
@@ -63,7 +65,7 @@ class QMPlay2FileWriter : public IODeviceWriter
 
     bool open() override final
     {
-        m_io.reset(new QSaveFile(getUrl().mid(7)));
+        m_io.reset(new QFile(getUrl().mid(7)));
         return IODeviceWriter::open();
     }
 };
diff --git a/src/qmplay2/YouTubeDL.cpp b/src/qmplay2/YouTubeDL.cpp
index f05e615b..8e3e757d 100644
--- a/src/qmplay2/YouTubeDL.cpp
+++ b/src/qmplay2/YouTubeDL.cpp
@@ -23,26 +23,33 @@
 #include <Functions.hpp>
 #include <CppUtils.hpp>
 
-#include <QStandardPaths>
-#include <QJsonDocument>
-#include <QJsonObject>
-#include <QJsonArray>
+#include <QRegExp>
 #include <QFileInfo>
 #include <QMutex>
 #include <QFile>
 
+#include <QJsonArray.h>
+#include <QJsonDocument.h>
+#include <QJsonObject.h>
+
+/* Avoid downloading yt-dlp, it fails to work correctly. */
+#ifndef BUNDLED_YTDLP
+#define BUNDLED_YTDLP 0
+#endif
+
 constexpr const char *g_name = "YouTubeDL";
 static bool g_mustUpdate = true;
 static QMutex g_mutex(QMutex::Recursive);
 
 QString YouTubeDL::getFilePath()
 {
-    return QMPlay2Core.getSettingsDir() + "youtube-dl"
+    return QMPlay2Core.getSettingsDir() + "yt-dlp"
 #ifdef Q_OS_WIN
     ".exe"
 #endif
     ;
 }
+
 QStringList YouTubeDL::getCommonArgs()
 {
     QStringList commonArgs {
@@ -164,7 +171,7 @@ QStringList YouTubeDL::exec(const QString &url, const QStringList &args, QString
         startProcess(processArgs);
     }
 
-    if (!m_process.waitForFinished() || m_aborted)
+    if (!m_process.waitForFinished(-1) || m_aborted)
         return {};
 
     QStringList result;
@@ -181,7 +188,7 @@ QStringList YouTubeDL::exec(const QString &url, const QStringList &args, QString
         }
         else
         {
-            result = result.constFirst().split('\n', QString::SkipEmptyParts);
+            result = result[0].split('\n', QString::SkipEmptyParts);
 
             // Verify if URLs has printable characters, because sometimes we
             // can get binary garbage at output (especially on Openload).
@@ -267,7 +274,7 @@ bool YouTubeDL::prepare()
         if (m_aborted)
             return false;
     }
-
+#if BUNDLED_YTDLP
     if (!QFileInfo(m_ytDlPath).exists())
     {
         if (!download())
@@ -297,7 +304,7 @@ bool YouTubeDL::prepare()
     }
 
     ensureExecutable();
-
+#endif
     g_mutex.unlock();
     return true;
 }
@@ -305,8 +312,8 @@ bool YouTubeDL::prepare()
 bool YouTubeDL::download()
 {
     // Mutex must be locked here
-
-    const QString downloadUrl = "https://yt-dl.org/downloads/latest/youtube-dl"
+#if BUNDLED_YTDLP
+    const QString downloadUrl = "https://github.com/yt-dlp/yt-dlp/releases/latest/download/yt-dlp"
 #ifdef Q_OS_WIN
     ".exe"
 #endif
@@ -354,11 +361,13 @@ bool YouTubeDL::download()
 
     QMPlay2Core.setWorking(false);
     return false;
+#endif
 }
+
 bool YouTubeDL::update()
 {
     // Mutex must be locked here
-
+#if BUNDLED_YTDLP
     qDebug() << "\"youtube-dl\" updates will be checked";
     QMPlay2Core.setWorking(true);
 
@@ -390,29 +399,11 @@ bool YouTubeDL::update()
         {
             qCritical() << "youtube-dl update failed:" << updateOutput;
         }
-        else if (m_process.exitCode() == 0 && !updateOutput.contains("up-to-date"))
+        else if (m_process.exitCode() == 0 && !updateOutput.contains(QRegExp(R"(up\Wto\Wdate)")))
         {
-#ifdef Q_OS_WIN
-            const QString updatedFile = m_ytDlPath + ".new";
-            QFile::remove(Functions::filePath(m_ytDlPath) + "youtube-dl-updater.bat");
-            if (QFile::exists(updatedFile))
-            {
-                Functions::s_wait(0.2); // Wait 200 ms to be sure that file is closed
-                QFile::remove(m_ytDlPath);
-                if (QFile::rename(updatedFile, m_ytDlPath))
-                {
-#endif
-                    QMPlay2Core.setWorking(false);
-                    emit QMPlay2Core.sendMessage(tr("\"youtube-dl\" has been successfully updated!"), g_name);
-                    return true;
-#ifdef Q_OS_WIN
-                }
-            }
-            else
-            {
-                qDebug() << "Updated youtube-dl file:" + updatedFile + "not found!";
-            }
-#endif
+                QMPlay2Core.setWorking(false);
+                emit QMPlay2Core.sendMessage(tr("\"youtube-dl\" has been successfully updated!"), g_name);
+                return {};
         }
     }
     else if (updating && m_aborted)
@@ -421,6 +412,7 @@ bool YouTubeDL::update()
     }
 
     QMPlay2Core.setWorking(false);
+#endif
     return true;
 }
 
@@ -460,24 +452,7 @@ void YouTubeDL::startProcess(QStringList args)
         if (shebang.startsWith("#!") && idx > -1)
         {
             const auto pythonCmd = shebang.mid(idx);
-            if (!QStandardPaths::findExecutable(pythonCmd).endsWith(pythonCmd))
-            {
-                QStringList pythonCmdsToCheck {
-                    "python",
-                    "python2",
-                    "python3",
-                };
-                pythonCmdsToCheck.removeOne(pythonCmd);
-                for (auto &&pythonCmd : asConst(pythonCmdsToCheck))
-                {
-                    if (QStandardPaths::findExecutable(pythonCmd).endsWith(pythonCmd))
-                    {
-                        args.prepend(program);
-                        program = pythonCmd;
-                        break;
-                    }
-                }
-            }
+            // We do not want to fetch yt-dlp anyway.
         }
         ytDlFile.close();
     }
diff --git a/src/qmplay2/headers/ColorButton.hpp b/src/qmplay2/headers/ColorButton.hpp
index 75aa784a..a9b8c5e0 100644
--- a/src/qmplay2/headers/ColorButton.hpp
+++ b/src/qmplay2/headers/ColorButton.hpp
@@ -22,7 +22,7 @@
 
 #include <QPushButton>
 
-class QMPLAY2SHAREDLIB_EXPORT ColorButton final : public QPushButton
+class ColorButton : public QPushButton
 {
     Q_OBJECT
 public:
@@ -34,7 +34,7 @@ public:
         return m_color;
     }
 protected:
-    void paintEvent(QPaintEvent *) override;
+    void paintEvent(QPaintEvent *) override final;
 private:
     QColor m_color;
     bool m_alphaChannel;
diff --git a/src/qmplay2/headers/IPC.hpp b/src/qmplay2/headers/IPC.hpp
index 4766b238..8ebd4b3c 100644
--- a/src/qmplay2/headers/IPC.hpp
+++ b/src/qmplay2/headers/IPC.hpp
@@ -31,18 +31,18 @@ class IPCServerPriv;
 
 class QSocketNotifier;
 
-class QMPLAY2SHAREDLIB_EXPORT IPCSocket final : public QIODevice
+class IPCSocket : public QIODevice
 {
     Q_OBJECT
     friend class IPCServer;
 public:
     IPCSocket(const QString &fileName, QObject *parent = nullptr);
-    ~IPCSocket();
+    ~IPCSocket() final;
 
     bool isConnected() const;
 
-    bool open(OpenMode mode) override;
-    void close() override;
+    bool open(OpenMode mode) override final;
+    void close() override final;
 
 private slots:
     void socketReadActive();
@@ -54,20 +54,20 @@ private:
     IPCSocket(int socket, QObject *parent);
 #endif
 
-    qint64 readData(char *data, qint64 maxSize) override;
-    qint64 writeData(const char *data, qint64 maxSize) override;
+    qint64 readData(char *data, qint64 maxSize) override final;
+    qint64 writeData(const char *data, qint64 maxSize) override final;
 
     IPCSocketPriv *m_priv;
 };
 
 /**/
 
-class QMPLAY2SHAREDLIB_EXPORT IPCServer final : public QObject
+class IPCServer : public QObject
 {
     Q_OBJECT
 public:
     IPCServer(const QString &fileName, QObject *parent = nullptr);
-    ~IPCServer();
+    ~IPCServer() final;
 
     bool listen();
     void close();
diff --git a/src/qmplay2/headers/InDockW.hpp b/src/qmplay2/headers/InDockW.hpp
index d4b51c50..67504fc5 100644
--- a/src/qmplay2/headers/InDockW.hpp
+++ b/src/qmplay2/headers/InDockW.hpp
@@ -23,7 +23,7 @@
 #include <QPointer>
 #include <QWidget>
 
-class QMPLAY2SHAREDLIB_EXPORT InDockW final : public QWidget
+class InDockW : public QWidget
 {
     Q_OBJECT
 public:
@@ -41,12 +41,12 @@ private:
     QPointer<QWidget> w;
 private slots:
     void wallpaperChanged(bool hasWallpaper, double alpha);
-public:
+public slots:
     void setWidget(QWidget *newW);
 protected:
-    void resizeEvent(QResizeEvent *) override;
-    void paintEvent(QPaintEvent *) override;
-    bool event(QEvent *) override;
+    void resizeEvent(QResizeEvent *) override final;
+    void paintEvent(QPaintEvent *) override final;
+    bool event(QEvent *) override final;
 signals:
     void resized(int, int);
     void itemDropped(const QString &);
diff --git a/src/qmplay2/headers/LineEdit.hpp b/src/qmplay2/headers/LineEdit.hpp
index 676be13e..b7606e40 100644
--- a/src/qmplay2/headers/LineEdit.hpp
+++ b/src/qmplay2/headers/LineEdit.hpp
@@ -21,16 +21,36 @@
 #include <QMPlay2Lib.hpp>
 
 #include <QLineEdit>
+#include <QLabel>
 
-class QMPLAY2SHAREDLIB_EXPORT LineEdit final : public QLineEdit
+class LineEditButton : public QLabel
 {
     Q_OBJECT
+public:
+    LineEditButton();
+private:
+    void mousePressEvent(QMouseEvent *) override final;
+signals:
+    void clicked();
+};
+
+/**/
 
+class LineEdit : public QLineEdit
+{
+    Q_OBJECT
 public:
     LineEdit(QWidget *parent = nullptr);
 
-    void clearText();
+private:
+    void resizeEvent(QResizeEvent *) override final;
+    void mousePressEvent(QMouseEvent *) override final;
+    void mouseMoveEvent(QMouseEvent *) override final;
 
+    LineEditButton b;
+private slots:
+    void textChangedSlot(const QString &);
+    void clearText();
 signals:
     void clearButtonClicked();
 };
diff --git a/src/qmplay2/headers/MkvMuxer.hpp b/src/qmplay2/headers/MkvMuxer.hpp
index f0f71a96..a49f5da0 100644
--- a/src/qmplay2/headers/MkvMuxer.hpp
+++ b/src/qmplay2/headers/MkvMuxer.hpp
@@ -26,7 +26,7 @@ struct AVFormatContext;
 class StreamInfo;
 struct Packet;
 
-class QMPLAY2SHAREDLIB_EXPORT MkvMuxer
+class MkvMuxer
 {
     MkvMuxer(const MkvMuxer &) = delete;
     MkvMuxer &operator =(const MkvMuxer &) = delete;
diff --git a/src/qmplay2/headers/Module.hpp b/src/qmplay2/headers/Module.hpp
index 5fee6266..442ef070 100644
--- a/src/qmplay2/headers/Module.hpp
+++ b/src/qmplay2/headers/Module.hpp
@@ -27,7 +27,7 @@
 
 class ModuleCommon;
 
-class QMPLAY2SHAREDLIB_EXPORT Module : public Settings
+class Module : public Settings
 {
     friend class ModuleCommon;
 public:
diff --git a/src/qmplay2/headers/ModuleCommon.hpp b/src/qmplay2/headers/ModuleCommon.hpp
index 89ea8782..42bc0c40 100644
--- a/src/qmplay2/headers/ModuleCommon.hpp
+++ b/src/qmplay2/headers/ModuleCommon.hpp
@@ -20,7 +20,7 @@
 
 #include <Module.hpp>
 
-class QMPLAY2SHAREDLIB_EXPORT ModuleCommon
+class ModuleCommon
 {
 public:
     virtual bool set();
diff --git a/src/qmplay2/headers/ModuleParams.hpp b/src/qmplay2/headers/ModuleParams.hpp
index d351c08e..ebc69315 100644
--- a/src/qmplay2/headers/ModuleParams.hpp
+++ b/src/qmplay2/headers/ModuleParams.hpp
@@ -24,7 +24,7 @@
 #include <QString>
 #include <QVariant>
 
-class QMPLAY2SHAREDLIB_EXPORT ModuleParams
+class ModuleParams
 {
     Q_DISABLE_COPY(ModuleParams)
 public:
diff --git a/src/qmplay2/headers/NetworkAccess.hpp b/src/qmplay2/headers/NetworkAccess.hpp
index fef728fb..1da4950c 100644
--- a/src/qmplay2/headers/NetworkAccess.hpp
+++ b/src/qmplay2/headers/NetworkAccess.hpp
@@ -26,7 +26,7 @@
 class NetworkReplyPriv;
 struct NetworkAccessParams;
 
-class QMPLAY2SHAREDLIB_EXPORT NetworkReply final : public QObject, public BasicIO
+class NetworkReply : public QObject, public BasicIO
 {
     Q_OBJECT
 
@@ -49,7 +49,6 @@ public:
         Download,
         Aborted
     };
-    Q_ENUM(Error)
 
     enum class Wait
     {
@@ -57,13 +56,12 @@ public:
         Timeout,
         Error
     };
-    Q_ENUM(Wait)
 
-    ~NetworkReply();
+    ~NetworkReply() final;
 
     QString url() const;
 
-    void abort() override;
+    void abort() override final;
 
     bool hasError() const;
     Error error() const;
@@ -86,7 +84,7 @@ private:
 
 /**/
 
-class QMPLAY2SHAREDLIB_EXPORT NetworkAccess : public QObject
+class NetworkAccess : public QObject
 {
     Q_OBJECT
 
diff --git a/src/qmplay2/headers/NetworkAccessJS.hpp b/src/qmplay2/headers/NetworkAccessJS.hpp
index 8cc77097..dd20c4e0 100644
--- a/src/qmplay2/headers/NetworkAccessJS.hpp
+++ b/src/qmplay2/headers/NetworkAccessJS.hpp
@@ -8,7 +8,7 @@
 
 class NetworkAccess;
 
-class QMPLAY2SHAREDLIB_EXPORT NetworkAccessJS : public QObject
+class NetworkAccessJS : public QObject
 {
     Q_OBJECT
 
diff --git a/src/qmplay2/headers/PixelFormats.hpp b/src/qmplay2/headers/PixelFormats.hpp
index 52e312db..64d4fe66 100644
--- a/src/qmplay2/headers/PixelFormats.hpp
+++ b/src/qmplay2/headers/PixelFormats.hpp
@@ -22,22 +22,27 @@
 
 #include <QVector>
 
+extern "C"
+{
+    #include <libavutil/pixfmt.h>
+}
+
 enum class QMPlay2PixelFormat
 {
     None = -1,
 
-    YUV420P,
-    YUVJ420P,
-    YUV422P,
-    YUVJ422P,
-    YUV444P,
-    YUVJ444P,
+    YUV420P = AV_PIX_FMT_YUV420P,
+    YUVJ420P = AV_PIX_FMT_YUVJ420P,
+    YUV422P = AV_PIX_FMT_YUV422P,
+    YUVJ422P = AV_PIX_FMT_YUVJ422P,
+    YUV444P = AV_PIX_FMT_YUV444P,
+    YUVJ444P = AV_PIX_FMT_YUVJ444P,
 
-    YUV410P,
-    YUV411P,
-    YUVJ411P,
-    YUV440P,
-    YUVJ440P,
+    YUV410P = AV_PIX_FMT_YUV410P,
+    YUV411P = AV_PIX_FMT_YUV411P,
+    YUVJ411P = AV_PIX_FMT_YUVJ411P,
+    YUV440P = AV_PIX_FMT_YUV440P,
+    YUVJ440P = AV_PIX_FMT_YUVJ440P,
 
     Count,
 };
@@ -53,6 +58,7 @@ enum class QMPlay2ColorSpace
     SMPTE240M,
     BT2020,
 };
+
 struct LumaCoefficients
 {
     float cR, cG, cB;
diff --git a/src/qmplay2/headers/QMPlay2Core.hpp b/src/qmplay2/headers/QMPlay2Core.hpp
index 7c73b00c..5cdf4815 100644
--- a/src/qmplay2/headers/QMPlay2Core.hpp
+++ b/src/qmplay2/headers/QMPlay2Core.hpp
@@ -94,7 +94,11 @@ public:
         return *settings;
     }
 
-    qreal getVideoDevicePixelRatio() const;
+    inline qreal getVideoDevicePixelRatio() const
+    {
+        return videoDevicePixelRatio;
+    }
+    void setVideoDevicePixelRatio();
 
     QIcon getIconFromTheme(const QString &iconName, const QIcon &fallback = QIcon());
 
@@ -211,6 +215,7 @@ private:
     QStringList logs;
     QMap<QString, QString> languages;
     QList<QPointer<QWidget>> videoFilters;
+    qreal videoDevicePixelRatio;
     QString lang;
 
     struct
diff --git a/src/qmplay2/headers/QMPlay2Lib.hpp b/src/qmplay2/headers/QMPlay2Lib.hpp
index 0d1f1016..8bc2a569 100644
--- a/src/qmplay2/headers/QMPlay2Lib.hpp
+++ b/src/qmplay2/headers/QMPlay2Lib.hpp
@@ -20,8 +20,13 @@
 
 #include <QtGlobal>
 
-#if defined(QMPLAY2SHAREDLIB_LIBRARY)
-    #define QMPLAY2SHAREDLIB_EXPORT Q_DECL_EXPORT
+#if QT_VERSION < QT_VERSION_CHECK(5, 0, 0)
+    // Define to nothing, it breaks linking otherwise
+    #define QMPLAY2SHAREDLIB_EXPORT
 #else
-    #define QMPLAY2SHAREDLIB_EXPORT Q_DECL_IMPORT
+    #if defined(QMPLAY2SHAREDLIB_LIBRARY)
+        #define QMPLAY2SHAREDLIB_EXPORT Q_DECL_EXPORT
+    #else
+        #define QMPLAY2SHAREDLIB_EXPORT Q_DECL_IMPORT
+    #endif
 #endif
diff --git a/src/qmplay2/headers/Slider.hpp b/src/qmplay2/headers/Slider.hpp
index 52acb3b0..d8d49ee9 100644
--- a/src/qmplay2/headers/Slider.hpp
+++ b/src/qmplay2/headers/Slider.hpp
@@ -22,7 +22,7 @@
 
 #include <QSlider>
 
-class QMPLAY2SHAREDLIB_EXPORT Slider final : public QSlider
+class Slider : public QSlider
 {
     Q_OBJECT
 public:
@@ -45,12 +45,12 @@ public slots:
     }
     void drawRange(int first, int second);
 protected:
-    void paintEvent(QPaintEvent *) override;
-    void mousePressEvent(QMouseEvent *) override;
-    void mouseReleaseEvent(QMouseEvent *) override;
-    void mouseMoveEvent(QMouseEvent *) override;
-    void wheelEvent(QWheelEvent *) override;
-    void enterEvent(QEvent *) override;
+    void paintEvent(QPaintEvent *) override final;
+    void mousePressEvent(QMouseEvent *) override final;
+    void mouseReleaseEvent(QMouseEvent *) override final;
+    void mouseMoveEvent(QMouseEvent *) override final;
+    void wheelEvent(QWheelEvent *) override final;
+    void enterEvent(QEvent *) override final;
 private:
     int getMousePos(const QPoint &pos);
 
diff --git a/src/qmplay2/headers/StreamInfo.hpp b/src/qmplay2/headers/StreamInfo.hpp
index 6a8951ac..ec830b88 100644
--- a/src/qmplay2/headers/StreamInfo.hpp
+++ b/src/qmplay2/headers/StreamInfo.hpp
@@ -26,6 +26,8 @@
 #include <QVector>
 #include <QPair>
 
+#include <qnumeric.h> // qQNaN
+
 using QMPlay2Tag = QPair<QString, QString>;
 
 enum QMPlay2MediaType
